<?php
// This script parse a simple text file in ADIF.
// F5LEN - Pascal Grandjean
// Send comments, bugs and suggestions to:
// f5len@ref-union.org
// October 2002 for TT8ZZ
// Modified en july 2003 for TM0HQ
// Modified december 2003 for TO4E
// Modified march 2004 for 5V7C
// Modified november 2005 for ADIF support
// Modified december 2005 for small bug if script name changed. (TNX EA7UU)

#  ********************************************************************
#  *** Edit lines below to change files names, display beahavior etc...
#  ********************************************************************

$fic_log="./example1.adi";			#Path and name of the log file

$TITLE="Your tittle";				#Tittle of your page
$titlesize=4;						#Tittle font size

# Table parameters
$HEAD="Online search in XXXXX's log";	#Header of the table
$font="Arial";				#Font name
$size=2;					#Font size
$fontcolor="#ffffff";		#Fontcolor

$alignment="center";		#center, left or right
$bgcolor="#6699FF";			#Background color 
$bordercolor="#9999ff";		#Border color
$labelcolor="#000000";		#Labelcolor

# Bands to show
# Comment bands you don't want to show
$show["160M"]="";		
$show["80M"]="";
$show["40M"]="";
$show["30M"]="";
$show["20M"]="";
$show["17M"]="";
$show["15M"]="";
$show["12M"]="";
$show["10M"]="";
#$show["6M"]="";
#$show["4M"]="";
#$show["2M"]="";
#$show["1.25M"]="";
#$show["70CM"]="";
#$show["33CM"]="";
#$show["23CM"]="";
#$show["13CM"]="";
#$show["9CM"]="";
#$show["6CM"]="";
#$show["3CM"]="";

#  *********************************************************************
#  *** Don't edit lines below if you are not sure about what you do! ***
#  *********************************************************************
$SCRIPT_NAME=$_SERVER['PHP_SELF'];
@$call=$_POST["call"];
?>

<html>

<head>
<meta http-equiv="Content-Language" content="fr">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>SearchLog</title>
</head>

<body>

<p align="center"><?php echo $TITLE; ?></p>

<div align="center">
  <center>
  <table border="0" cellpadding="2" cellspacing="1">
    <tr>
      <td>
<form method="POST" action="<?php echo $SCRIPT_NAME; ?>" target="_self">
  <div align="center">
    <table border="1" cellpadding="2" cellspacing="1" width="315">
      <tr>
        <td width="305" bgcolor="#6699FF" colspan="2">
          <p align="center"><font face="Arial"><b><?php echo $HEAD; ?></b></font></td>
      </tr>
      <tr>
        <td width="118" bgcolor="#6699FF">
          <p align="center"><font face="Arial">Your callsign&nbsp;</font></td>
        <td width="187" bgcolor="#6699FF">
          <p align="center"> <input type="text" name="call" size="20"></td>
      </tr>
  </center>
      <tr>
        <td width="297" bgcolor="#6699FF" colspan="2">
          <p align="center">&nbsp;<input type="submit" value="Search log" name="B1"><input type="reset" value="Clear" name="B2"></td>
      </tr>
    </table>
  </div>
</form>

      </td>
    </tr>
  </table>
</div>
<p></p>

<?php



$nb_band=count($show);
$nb_qso=0;
$call=strtoupper($call);
if (!$call) {
	$call = 'NOCALL';
}

if (@file_exists($fic_log)){
	$err_fic=0;
}else {
	$err_fic=1;
}

if ($call!='NOCALL' && $err_fic==0){

	$log=file($fic_log);

	# Recherche fin de l'entte.
	#
	while (list($numero_ligne,$ligne) = each($log)){
		if (eregi("<eoh>",$ligne)){
			$fin_header=$numero_ligne+1;
			break;
		}
	}

	#Constitution d'un tableau avec une ligne par record
	$nb_ligne=count($log);
	reset($log);
	@array($records);
	$i=0;
	while ($numero_ligne <= $nb_ligne){
		@$ligne=$log[$numero_ligne];
		$ligne=trim($ligne,"\r.\n");
		$ligne=strtoupper($ligne);
		if (!ereg("<EOR>",$ligne)){
			@$records[$i]=$records[$i].$ligne;
		}else {
			@$records[$i]=$records[$i].$ligne;
			$i++;
		}
		$numero_ligne++;
	}

	reset($records);
	$i=0;
	while (list($numero_ligne,$ligne) = each($records)){
		if (strlen($ligne) >10){
			ereg("<CALL:[0-9]+>([A-Z\/0-9.]+)",$ligne,$stockage);
			$indicatif=$stockage[1];
			if ($call==$indicatif){
				ereg("<BAND:[0-9]+>([A-Z0-9.]+)",$ligne,$stockage);
				$BANDE=$stockage[1]; 
				ereg("<MODE:[0-9]+>([A-Z0-9.]+)",$ligne,$stockage);
				$MODE=$stockage[1];
				$resultat[$i]="$indicatif;$BANDE;$MODE";
				$i++;
			}
		}
	}

	if (@is_array($resultat)){
		$nb_qso=count($resultat);
		while ( list( $numero_ligne, $ligne ) = each( $resultat ) ) {
			$DATAS=explode(";",$ligne);
			$mode=$DATAS[2];
			$qrg=$DATAS[1];
			if (isset($show[$qrg])){
				$show[$qrg]=$show[$qrg].$mode.";";
			}
		}

	}
	
	if ($nb_qso >0){
		echo '<div align="'.$alignment.'">';
		echo  '<table border="1" cellpadding="8" cellspacing="0" bgcolor="'.$bgcolor.'" bordercolor="'.$bordercolor.'">';
		echo  '<tr>';
		echo  '<td colspan="'.$nb_band.'"><font face="'.$font.'" size="'.$titlesize.'">Looking for <b>'.$call.'</b> </font></td>';
		echo  '</tr>';
		echo  '<tr>';

		while ( list( $numero_ligne, $ligne ) = each( $show ) ) {
			echo '<td><font face="'.$font.'" size="'.$size.'" color="'.$labelcolor.'">'.$numero_ligne.'</font></td>';
		}
		echo  '</tr>';
		echo  '<tr>';

		reset($show);
		while ( list( $numero_ligne, $ligne ) = each( $show ) ) {
			echo  '<td valign="top">';
			$bande=explode(";",$show[$numero_ligne]);
			$n=0;
			$nb_res=count($bande);
			if ($nb_res >1){
				while ( $n < $nb_res) {
					echo '<font face="'.$font.'" size="'.$size.'" color="'.$fontcolor.'">'.$bande[$n];
					if ($n<$nb_res-1){ echo '<br></font>';}
					else { echo '</font>';}
					$n++;
				}
			}
			else {
				echo '&nbsp';
			}
			echo '</td>';
		}

		echo  "</td>";
		echo  "</tr>";
		echo  '<tr>';
		echo  '<td colspan="'.$nb_band.'"><font face="'.$font.'" size="'.$titlesize.'">Total: <b>'.$nb_qso.'</b> QSO</font></td>';
		echo  '</tr>';
		echo  '<tr>';
		echo  '<td colspan="'.$nb_band.'"><p align="right"><font face="verdana" size="1" color="#6666FF"><i>Searchlog in php by F5LEN  1.0</i></font></td>';
		echo  '</tr>';
		echo  "</table>";
		echo "</div>";
	}else {
		echo '<div align="'.$alignment.'">';
		echo  '<table border="1" cellspacing="0" bgcolor="'.$bgcolor.'" bordercolor="'.$bordercolor.'">';
		echo  '<tr>';
		echo  '<td><font face="'.$font.'" size="'.$titlesize.'">Sorry no QSO found for <b>'.$call.'</b> in the log</font></td>';
		echo  '</tr>';
	}
}

if ($err_fic==1){
	echo "<center> Sorry script error<br>";
	echo "log file named: <b>$fic_log</b> not found.<br>";
	echo "Please check path and name of your log file at line 17.";
	echo "</center>";
}

# *** The end ouf ;-) ***
?>

</body>
</html>